#include <stdio.h>
#include <stdlib.h>

struct esame {
       int codice,voto;
       char data[12];
       long matricola;
       };

void leggi(struct esame *pe);
void inserisci(struct esame **Ve, int *pn, struct esame e);
void visualizza_riga(struct esame *Ve,int n);
void salva(struct esame *V[18], int N[18]);
void carica(struct esame *V[18], int N[18]);

main() {
       struct esame *V[18], es;
       int N[18];
       int scelta,i;
       
       /* inizializzazione della tabella*/
       for(i=0;i<18;i++)
        {  N[i]=0;
           V[i]=NULL;
        }
        
        do {
            printf("Scegli\n");
            printf("1) Inserimento\n2) Visualizzazione\n");
            printf("3) salvataggio\n4) Carica\n");
            printf("0) fine");
            scanf("%d",&scelta);
            switch(scelta) {
             case 1:   /*inserimento*/
                       leggi(&es);
                       i=es.codice;
                       inserisci(&V[i],&N[i],es);
                       break;
             case 2:   /* visualizzazione*/
                       for(i=0;i<18;i++)
                        { printf("Codice: %d\n",i);
                          visualizza_riga(V[i],N[i]);
                         }
                       break;
             case 3:   salva(V,N);
                       break;
             case 4:   carica(V,N);
                       break;
             default:;
             }
            } while(scelta!=0);
       
       for(i=0;i<18;i++)
         free(V[i]);
}


void leggi(struct esame *pe)
{
     printf("Codice materia (0..17) ");
     scanf("%d",&pe->codice);
     printf("Data esame: ");
     scanf("%s",pe->data);
     printf("Matricola: ");
     scanf("%ld",&pe->matricola);
     printf("Voto: ");
     scanf("%d",&pe->voto);
}

void inserisci(struct esame **Ve, int *pn, struct esame e)
{
    struct esame *Va;
    
    Va=(struct esame *) realloc(*Ve, (*pn+1)*sizeof(struct esame));
    if(Va==NULL)
       return;
    *Ve=Va;
    Va[*pn]=e;
    /* oppure  (*Ve)[*pn]=e; */
   (*pn)++;
}     
     
void visualizza_riga(struct esame *Ve,int n)
{
  int i;
  /* visualizzazione degli esami con voto >= 27 */
  for(i=0;i<n;i++)
    if(Ve[i].voto>=27)
    {
      printf("Matricola: %ld\n",Ve[i].matricola);
      printf("Voto: %d\n\n",Ve[i].voto);
    }
}
    

void salva(struct esame *V[18], int N[18])
{
     FILE *pf;
     char nomefile[80];
     int i;
     
     printf("Nome file\n");
     scanf("%s",nomefile);
     pf=fopen(nomefile,"w");
     if(pf) {
              for(i=0;i<18;i++)
                fwrite(V[i],sizeof(struct esame),N[i],pf);
              fclose(pf);
              }
}  
     
void carica(struct esame *V[18], int N[18])
{
     FILE *pf;
     char nomefile[80];
     struct esame es;
     int i;
     
     printf("Nome file ");
     scanf("%s",nomefile);
     pf=fopen(nomefile,"r");
     if(pf) {
             while(fread(&es,sizeof(struct esame),1,pf)!=0)
               {i=es.codice;
                inserisci(&V[i],&N[i],es);
                }
             fclose(pf);
             }
     else printf("File inesistente\n");
}
                
                       
                       
       
       
       
       
       
       
       








