#include <stdio.h>
#include <stdlib.h>

struct esame {
       int codice,voto;
       char data[12];
       long matricola;
       };

void leggi(struct esame *pe);
void inserisci(struct esame *V[18], int N[18], struct esame e);
void visualizza(struct esame *V[18],int N[18]);
void salva(struct esame *V[18], int N[18]);
void carica(struct esame *V[18], int N[18]);

main() {
       struct esame *V[18], es;
       int N[18];
       int scelta,i;
       
       /* inizializzazione della tabella*/
       for(i=0;i<18;i++)
        {  N[i]=0;
           V[i]=NULL;
        }
        
        do {
            printf("Scegli\n");
            printf("1) Inserimento\n2) Visualizzazione\n");
            printf("3) salvataggio\n4) Carica\n");
            printf("0) fine");
            scanf("%d",&scelta);
            switch(scelta) {
             case 1:   /*inserimento*/
                       leggi(&es);
                       inserisci(V,N,es);
                       break;
             case 2:   /* visualizzazione*/
                       visualizza(V,N);
                       break;
             case 3:   salva(V,N);
                       break;
             case 4:   carica(V,N);
                       break;
             default:;
             }
            } while(scelta!=0);
       
       for(i=0;i<18;i++)
         free(V[i]);
}


void leggi(struct esame *pe)
{
     printf("Codice materia (0..17) ");
     scanf("%d",&pe->codice);
     printf("Data esame: ");
     scanf("%s",pe->data);
     printf("Matricola: ");
     scanf("%ld",&pe->matricola);
     printf("Voto: ");
     scanf("%d",&pe->voto);
}

void inserisci(struct esame *V[18], int N[18], struct esame e)
{
    struct esame *Va;
    int i;
    
    i=e.codice;
    
    Va=(struct esame *) realloc(V[i], (N[i]+1)*sizeof(struct esame));
    if(Va==NULL)
       return;
    V[i]=Va;
    Va[N[i]]=e;
    /* oppure  V[i][N[i]]=e; */
   N[i]++;
}     
     
void visualizza(struct esame *V[18],int N[18])
{
  int i,j;
  /* visualizzazione degli esami con voto >= 27 */
  
  for(j=0;j<18;j++)
  { printf("Codice: %d\n",j);
   for(i=0;i<N[j];i++)
    if(V[j][i].voto>=27)
    {
      printf("Matricola: %ld\n",V[j][i].matricola);
      printf("Voto: %d\n\n",V[j][i].voto);
    }
  }
}
    

void salva(struct esame *V[18], int N[18])
{
     FILE *pf;
     char nomefile[80];
     int i;
     
     printf("Nome file\n");
     scanf("%s",nomefile);
     pf=fopen(nomefile,"w");
     if(pf) {
              for(i=0;i<18;i++)
                fwrite(V[i],sizeof(struct esame),N[i],pf);
              fclose(pf);
              }
}  
     
void carica(struct esame *V[18], int N[18])
{
     FILE *pf;
     char nomefile[80];
     struct esame es;
     int i;
     
     printf("Nome file ");
     scanf("%s",nomefile);
     pf=fopen(nomefile,"r");
     if(pf) {
             while(fread(&es,sizeof(struct esame),1,pf)!=0)
               {i=es.codice;
                inserisci(&V[i],&N[i],es);
                }
             fclose(pf);
             }
     else printf("File inesistente\n");
}
                
                       
                       
       
       
       
       
       
       
       








